Skip to main content
`Ctrl`+`K`

# DMSetMatrixPreallocateOnly

When `DMCreateMatrix()` is called the matrix will be properly preallocated but the nonzero structure and zero values will not be set.

## Synopsis

    #include "petscdm.h"
    #include "petscdmlabel.h"
    #include "petscds.h"
    PetscErrorCode DMSetMatrixPreallocateOnly(DM dm, PetscBool only)

Logically Collective

## Input Parameters

- dm - the `DM`

- only - `PETSC_TRUE` if only want preallocation

## Options Database Key

- -dm_preallocate_only - Only preallocate the matrix for `DMCreateMatrix()`, `DMCreateMassMatrix()`, but do not fill it with zeros

## See Also

DM Basics, `DM`, `DMCreateMatrix()`, `DMCreateMassMatrix()`, `DMSetMatrixStructureOnly()`, `DMSetMatrixPreallocateSkip()`

## Level

developer

## Location

src/dm/interface/dm.c

## Examples

src/tao/unconstrained/tutorials/burgers_spectral.c
src/dm/impls/stag/tutorials/ex8.c
src/ts/tutorials/ex50.c
src/tao/unconstrained/tutorials/spectraladjointassimilation.c

Index of all DM routines
Table of Contents for all manual pages
Index of all manual pages